(function ($) {
    "use strict";

    $(window).on('load', function () {

        ////////// Vertical Start //////////
        if ($('.cv-titles').length > 0) {

            var interleaveOffset = 0.5;

            var cvImagesSwiper = new Swiper('.cv-images-swiper', {
                slidesPerView: 1,
                parallax: true,
                mousewheel: {
                    invert: false,
                },
                watchSlidesProgress: true,
                on: {
                    progress: function () {
                        let swiper = this;
                        for (let i = 0; i < swiper.slides.length; i++) {
                            let slideProgress = swiper.slides[i].progress,
                                innerOffset = swiper.width * interleaveOffset,
                                innerTranslate = slideProgress * innerOffset;

                            swiper.slides[i].querySelector(".slide-bgimg").style.transform =
                                "translateX(" + innerTranslate + "px)";

                        }
                    },
                    setTransition: function (speed) {
                        let swiper = this;
                        for (let i = 0; i < swiper.slides.length; i++) {
                            swiper.slides[i].style.transition = speed + "ms";
                            swiper.slides[i].querySelector(".slide-bgimg").style.transition =
                                speed + "ms";
                        }
                    }
                }

            });

            var cvTitles = new Swiper('.cv-titles', {
                slidesPerView: 1,
                mousewheel: {
                    invert: false,

                },
                centeredSlides: true,
                speed: 1000,
                effect: 'fade',
                fadeEffect: {
                    crossFade: true
                },
                autoplay: true,
                navigation: {
                    nextEl: '.cv-slide-next',
                    prevEl: '.cv-slide-prev',
                },
                pagination: {
                    el: '.cv-slide-fraction',
                    type: 'fraction',
                    renderFraction: function (currentClass, totalClass) {
                        return '<span class="' + currentClass + '"></span>' + '<span class="cv-frac-line">/</span>' +
                            '<span class="' + totalClass + '"></span>';
                    },

                },
            });

            cvTitles.controller.control = cvImagesSwiper;

            var cbColor = $('.swiper-slide-active').data('color');

            $('.cv-images-back, .portfolio-trans-overlay').css({
                backgroundColor: cbColor
            });

            $('.cv-title, .cv-summary, .cv-discover, .cv-slide-pagination i , .cv-slide-fraction span').css({
                color: cbColor
            });

            cvTitles.on('slideChangeTransitionStart', function () {

                var cbColor = $('.swiper-slide-active').data('color');
                $('.cv-images-back, .portfolio-trans-overlay').css({
                    background: cbColor
                });

                setTimeout(function () {

                    $('.cv-title, .cv-summary, .cv-discover, .cv-slide-pagination i , .cv-slide-fraction span').css({
                        color: cbColor
                    })
                }, 200)

            });

        };
        ////////// Vertical End //////////

    });
})(jQuery);
